HDF5 C++ API Reference Manual

- Main Page
- Namespaces
- Classes
- Files
- Examples

- Class List
- Class Hierarchy
- Class Members

# H5::FileAccPropList Class Reference

`#include <H5FaccProp.h>`

Inheritance diagram for H5::FileAccPropList:

List of all members.

## Public Member Functions
| FileAccPropList ()
| Creates a file access property list.
void | setStdio () const
| Modifies this property list to use the `H5FD_STDIO` driver.
void | setDriver (hid_t new_driver_id, const void *new_driver_info) const
| Set file driver for this property list.
hid_t | getDriver () const
| Return the ID of the low-level file driver.
void | setFamilyOffset (hsize_t offset) const
| Sets offset for family driver.
hsize_t | getFamilyOffset () const
| Get offset for family driver.
void | setSec2 () const
| Modifies this file access property list to use the sec2 driver.
void | setCore (size_t increment, hbool_t backing_store) const
| Modifies this file access property list to use the `H5FD_CORE` driver.
void | getCore (size_t &increment, hbool_t &backing_store) const
| Queries core file driver properties.
void | setFamily (hsize_t memb_size, const FileAccPropList &memb_plist) const
| Sets this file access property list to use the family driver.
void | getFamily (hsize_t &memb_size, FileAccPropList &memb_plist) const
| Returns information about the family file access property list.
FileAccPropList | getFamily (hsize_t &memb_size) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts and its return value.
void | setSplit (FileAccPropList &meta_plist, FileAccPropList &raw_plist, const char *meta_ext=".meta", const char *raw_ext=".raw") const
| Emulates the old split file driver, which stored meta data in one file and raw data in another file.
void | setSplit (FileAccPropList &meta_plist, FileAccPropList &raw_plist, const H5std_string &meta_ext, const H5std_string &raw_ext) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts.
void | setSieveBufSize (size_t bufsize) const
| Sets the maximum size of the data sieve buffer.
size_t | getSieveBufSize () const
| Returns the current settings for the data sieve buffer size property from this property list.
void | setMetaBlockSize (hsize_t &block_size) const
| Sets the minimum size of metadata block allocations.
hsize_t | getMetaBlockSize () const
| Returns the current metadata block size setting.
void | setLog (const char *logfile, unsigned flags, size_t buf_size) const
| Modifies this file access property list to use the logging driver.
void | setLog (const H5std_string &logfile, unsigned flags, size_t buf_size) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts.
void | setAlignment (hsize_t threshold=1, hsize_t alignment=1) const
| Sets the alignment properties of this property list.
void | getAlignment (hsize_t &threshold, hsize_t &alignment) const
| Returns the current settings for alignment properties from this property list.
void | setMultiType (H5FD_mem_t dtype) const
| Sets data type for `MULTI` driver.
H5FD_mem_t | getMultiType () const
| Returns the data type property for `MULTI` driver.
void | setCache (int mdc_nelmts, size_t rdcc_nelmts, size_t rdcc_nbytes, double rdcc_w0) const
| Sets the meta data cache and raw data chunk cache parameters. Sets the meta data cache and raw data chunk cache parameters.
void | getCache (int &mdc_nelmts, size_t &rdcc_nelmts, size_t &rdcc_nbytes, double &rdcc_w0) const
| Queries the meta data cache and raw data chunk cache parameters.
void | setFcloseDegree (H5F_close_degree_t degree)
| Sets the degree for the file close behavior.
H5F_close_degree_t | getFcloseDegree ()
| Returns the degree for the file close behavior.
void | setGcReferences (unsigned gc_ref=0) const
| Sets garbage collecting references flag.
unsigned | getGcReferences () const
| Returns the garbage collecting references setting.
virtual H5std_string | fromClass () const
| FileAccPropList (const FileAccPropList &original)
| Copy Constructor: makes a copy of the original FileAccPropList object.
| FileAccPropList (const hid_t plist_id)
| Creates a file access property list using the id of an existing one.
virtual | ~FileAccPropList ()
| Noop destructor.
## Static Public Attributes
static const FileAccPropList | DEFAULT
| Constant for default property.

## Constructor & Destructor Documentation

H5::FileAccPropList::FileAccPropList | ( |  | ) |

Creates a file access property list.

H5::FileAccPropList::FileAccPropList | ( | const FileAccPropList & | original | ) |

Copy Constructor: makes a copy of the original FileAccPropList object.

H5::FileAccPropList::FileAccPropList | ( | const hid_t | plist_id | ) |

Creates a file access property list using the id of an existing one.

H5::FileAccPropList::~FileAccPropList | ( |  | ) | `[virtual]`

Noop destructor.

## Member Function Documentation

void H5::FileAccPropList::setStdio | ( |  | ) | const

Modifies this property list to use the `H5FD_STDIO` driver.

Exceptions:

  | H5::PropListIException |

void H5::FileAccPropList::setDriver | ( | hid_t | new_driver_id,
|  | const void * | new_driver_info |
| ) |  |  | const

Set file driver for this property list.

Parameters:

  | new_driver_id | - IN: File driver
  | new_driver_info | - IN: Struct containing the driver-specific properites

Exceptions:

  | H5::PropListIException |

Description
  For a list of valid driver identifiers, please see the C layer Reference Manual at: ../RM_H5P.html::Property-GetDriver

hid_t H5::FileAccPropList::getDriver | ( |  | ) | const

Return the ID of the low-level file driver.

Returns:
  A low-level driver ID which is the same ID used when the driver was set for the property list. The driver ID is only valid as long as the file driver remains registered. Valid driver identifiers can be found at: ../RM_H5P.html::Property-GetDriver

Exceptions:

  | H5::PropListIException |

void H5::FileAccPropList::setFamilyOffset | ( | hsize_t | offset | ) | const

Sets offset for family driver.

Parameters:

  | offset | - IN: offset value

Exceptions:

  | H5::PropListIException |

hsize_t H5::FileAccPropList::getFamilyOffset | ( |  | ) | const

Get offset for family driver.

Returns:
  Offset for family driver

Exceptions:

  | H5::PropListIException |

void H5::FileAccPropList::setSec2 | ( |  | ) | const

Modifies this file access property list to use the sec2 driver.

Exceptions:

  | H5::PropListIException |

void H5::FileAccPropList::setCore | ( | size_t | increment,
|  | hbool_t | backing_store |
| ) |  |  | const

Modifies this file access property list to use the `H5FD_CORE` driver.

Parameters:

  | increment | - IN: Specifies how much memory to increase each time more memory is needed, in bytes
  | backing_store | - IN: Indicating whether to write the file contents to disk when the file is closed

Exceptions:

  | H5::PropListIException |

Description
  For more details on the use of `H5FD_CORE` driver, please refer to ../RM_H5P.html::Property-SetFaplCore

void H5::FileAccPropList::getCore | ( | size_t & | increment,
|  | hbool_t & | backing_store |
| ) |  |  | const

Queries core file driver properties.

Parameters:

  | increment | - OUT: Size of memory increment, in bytes
  | backing_store | - OUT: Indicating whether to write the file contents to disk when the file is closed

Exceptions:

  | H5::PropListIException |

void H5::FileAccPropList::setFamily | ( | hsize_t | memb_size,
|  | const FileAccPropList & | memb_plist |
| ) |  |  | const

Sets this file access property list to use the family driver.

Parameters:

  | memb_size | - IN: Size in bytes of each file member
  | memb_plist | - IN: File access property list to be used for each family member

Exceptions:

  | H5::PropListIException |

Description
  Note that memb_size is used only when creating a new file.

void H5::FileAccPropList::getFamily | ( | hsize_t & | memb_size,
|  | FileAccPropList & | memb_plist |
| ) |  |  | const

Returns information about the family file access property list.

Parameters:

  | memb_size | - OUT: Size in bytes of each file member
  | memb_plist | - OUT: Retrieved file access property list for each file member

Exceptions:

  | H5::PropListIException |

FileAccPropList H5::FileAccPropList::getFamily | ( | hsize_t & | memb_size | ) | const

This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts and its return value.

Parameters:

  | memb_size | - OUT: Size in bytes of each file member

Returns:
  The file access property list for each file member

Exceptions:

  | H5::PropListIException |

void H5::FileAccPropList::setSplit | ( | FileAccPropList & | meta_plist,
|  | FileAccPropList & | raw_plist,
|  | const char * | meta_ext = `".meta"`,
|  | const char * | raw_ext = `".raw"` |
| ) |  |  | const

Emulates the old split file driver, which stored meta data in one file and raw data in another file.

Parameters:

  | meta_plist | - IN: File access plist for the metadata file
  | raw_plist | - IN: File access plist for the raw data file
  | meta_ext | - IN: Metadata filename extension as `char*`
  | raw_ext | - IN: Raw data filename extension as `char*`

Exceptions:

  | H5::PropListIException |

Description
  Temporary - For information, please refer to: ../RM_H5P.html::Property-SetFaplSplit

void H5::FileAccPropList::setSplit | ( | FileAccPropList & | meta_plist,
|  | FileAccPropList & | raw_plist,
|  | const H5std_string & | meta_ext,
|  | const H5std_string & | raw_ext |
| ) |  |  | const

This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts.

Parameters:

  | meta_plist | - IN: File access plist for the metadata file
  | raw_plist | - IN: File access plist for the raw data file
  | meta_ext | - IN: Metadata filename extension as `string`
  | raw_ext | - IN: Raw data filename extension as `string`

Exceptions:

  | H5::PropListIException |

void H5::FileAccPropList::setSieveBufSize | ( | size_t | bufsize | ) | const

Sets the maximum size of the data sieve buffer.

Parameters:

  | bufsize | - IN: Maximum size, in bytes, of data sieve buffer

Exceptions:

  | H5::PropListIException |

Description
  For detail on data sieving, please refer to ../RM_H5P.html::Property-SetFaplStream../RM_H5P.html::Property-SetFaplStream

size_t H5::FileAccPropList::getSieveBufSize | ( |  | ) | const

Returns the current settings for the data sieve buffer size property from this property list.

Returns:
  Data sieve buffer size, in bytes

Exceptions:

  | H5::PropListIException |

void H5::FileAccPropList::setMetaBlockSize | ( | hsize_t & | block_size | ) | const

Sets the minimum size of metadata block allocations.

Parameters:

  | block_size | - IN: Minimum size, in bytes, of metadata block allocations

Exceptions:

  | H5::PropListIException |

Description
  For more detail, please see the C layer Reference Manual at: ../RM_H5P.html::Property-SetMetaBlockSize

hsize_t H5::FileAccPropList::getMetaBlockSize | ( |  | ) | const

Returns the current metadata block size setting.

Returns:
  Metadata block size

Exceptions:

  | H5::PropListIException |

void H5::FileAccPropList::setLog | ( | const char * | logfile,
|  | unsigned | flags,
|  | size_t | buf_size |
| ) |  |  | const

Modifies this file access property list to use the logging driver.

Parameters:

  | logfile | - IN: Name of the log file
  | flags | - IN: Flags specifying the types of logging activity
  | buf_size | - IN: Size of the logging buffer

Exceptions:

  | H5::PropListIException |

Description
  For detail on flags, please refer to ../RM_H5P.html::Property-SetFaplStream

void H5::FileAccPropList::setLog | ( | const H5std_string & | logfile,
|  | unsigned | flags,
|  | size_t | buf_size |
| ) |  |  | const

This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts.

Parameters:

  | logfile | - IN: Name of the log file - string
  | flags | - IN: Flags specifying the types of logging activity
  | buf_size | - IN: Size of the logging buffer

void H5::FileAccPropList::setAlignment | ( | hsize_t | threshold = `1`,
|  | hsize_t | alignment = `1` |
| ) |  |  | const

Sets the alignment properties of this property list.

Parameters:

  | threshold | - IN: Threshold value for file object size
  | alignment | - IN: Alignment value

Exceptions:

  | H5::PropListIException |

Description
  The parameter threshold must have a non-negative value. Note that setting the threshold value to 0 (zero) has the effect of a special case, forcing everything to be aligned. The parameter alignment must have a positive value.

For detail on setting alignment, please refer to ../RM_H5P.html::Property-SetAlignment

void H5::FileAccPropList::getAlignment | ( | hsize_t & | threshold,
|  | hsize_t & | alignment |
| ) |  |  | const

Returns the current settings for alignment properties from this property list.

Parameters:

  | threshold | - OUT: Retrieved threshold value for file object size
  | alignment | - OUT: Retrieved alignment value

Exceptions:

  | H5::PropListIException |

void H5::FileAccPropList::setMultiType | ( | H5FD_mem_t | dtype | ) | const

Sets data type for `MULTI` driver.

Parameters:

  | dtype | - IN: Type of data

Exceptions:

  | H5::PropListIException |

Description
  More details and valid values for dtype can be found at: ../RM_H5P.html::Property-SetMultiType

H5FD_mem_t H5::FileAccPropList::getMultiType | ( |  | ) | const

Returns the data type property for `MULTI` driver.

Returns:
  The data type property

Exceptions:

  | H5::PropListIException |

Description
  More details and possible returned values can be found at: ../RM_H5P.html::Property-GetMultiType

void H5::FileAccPropList::setCache | ( | int | mdc_nelmts,
|  | size_t | rdcc_nelmts,
|  | size_t | rdcc_nbytes,
|  | double | rdcc_w0 |
| ) |  |  | const

Sets the meta data cache and raw data chunk cache parameters. Sets the meta data cache and raw data chunk cache parameters.

Parameters:

  | mdc_nelmts | - IN: Number of elements in the meta data cache
  | rdcc_nelmts | - IN: Number of elements in the raw data chunk cache
  | rdcc_nbytes | - IN: Total size of the raw data chunk cache, in bytes
  | rdcc_w0 | - IN: Preemption policy

Exceptions:

  | H5::PropListIException |

Description
  The argument rdcc_w0 should hold a value between 0 and 1 inclusive. This value indicates how much chunks that have been fully read are favored for preemption. A value of zero means fully read chunks are treated no differently than other chunks (the preemption is strictly LRU) while a value of one means fully read chunks are always preempted before other chunks.

void H5::FileAccPropList::getCache | ( | int & | mdc_nelmts,
|  | size_t & | rdcc_nelmts,
|  | size_t & | rdcc_nbytes,
|  | double & | rdcc_w0 |
| ) |  |  | const

Queries the meta data cache and raw data chunk cache parameters.

Parameters:

  | mdc_nelmts | - OUT: Number of elements in the meta data cache
  | rdcc_nelmts | - OUT: Number of elements in the raw data chunk cache
  | rdcc_nbytes | - OUT: Total size of the raw data chunk cache, in bytes
  | rdcc_w0 | - OUT: Preemption policy

Exceptions:

  | H5::PropListIException |

void H5::FileAccPropList::setFcloseDegree | ( | H5F_close_degree_t | degree | ) |

Sets the degree for the file close behavior.

Parameters:

  | degree | - IN:

Exceptions:

  | H5::PropListIException |

H5F_close_degree_t H5::FileAccPropList::getFcloseDegree | ( |  | ) |

Returns the degree for the file close behavior.

Returns:
  The degree for the file close behavior

Exceptions:

  | H5::PropListIException |

void H5::FileAccPropList::setGcReferences | ( | unsigned | gc_ref = `0` | ) | const

Sets garbage collecting references flag.

Parameters:

  | gc_ref | - IN: Flag setting reference garbage collection to on (1) or off (0).

Exceptions:

  | H5::PropListIException |

Description
  For detail on fapl, please refer to ../RM_H5P.html::Property-SetFaplStream

unsigned H5::FileAccPropList::getGcReferences | ( |  | ) | const

Returns the garbage collecting references setting.

Returns:
  Garbage collecting references setting, 0 (off) or 1 (on)

Exceptions:

  | H5::PropListIException |

virtual H5std_string H5::FileAccPropList::fromClass | ( |  | ) | const`[inline, virtual]`

Reimplemented from H5::PropList.

## Member Data Documentation

const FileAccPropList H5::FileAccPropList::DEFAULT`[static]`

Constant for default property.

Reimplemented from H5::PropList.